diff -u -Naur eperl-2.2.14/eperl_main.c eperl-2.2.14.fink/eperl_main.c
--- eperl-2.2.14/eperl_main.c	Mon Jul 27 05:24:18 1998
+++ eperl-2.2.14.fink/eperl_main.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -37,9 +37,12 @@
 #include "eperl_global.h"
 #include "eperl_security.h"
 #include "eperl_getopt.h"
-#include "eperl_perl5.h"
 #include "eperl_proto.h"
 
+#define _EPERL_VERSION_C_AS_HEADER_
+#include "eperl_version.c"
+#undef  _EPERL_VERSION_C_AS_HEADER_
+
 int mode = MODE_UNKNOWN;
 
 char *allowed_file_ext[]   = LIST_OF_ALLOWED_FILE_EXT;
@@ -56,7 +59,8 @@
     char *cp;
 
     va_start(ap, str);
-    vsprintf(ca, str, ap);
+    vsnprintf(ca, sizeof(ca), str, ap);
+    ca[sizeof(ca)-1] = NUL;
 
     IO_restore_stdout();
     IO_restore_stderr();
@@ -64,7 +68,7 @@
     if (mode == MODE_CGI || mode == MODE_NPHCGI) {
         if (mode == MODE_NPHCGI)
             HTTP_PrintResponseHeaders("");
-        printf("Content-Type: text/html\n\n");
+        printf("Content-Type: text/html\r\n\r\n");
         printf("<html>\n");
         printf("<head>\n");
         printf("<title>ePerl: ERROR: %s</title>\n", ca);
@@ -80,7 +84,7 @@
         printf("<td><img src=\"%s/logo.gif\" alt=\"Embedded Perl 5 Language\"></td>\n", cp);
         printf("</tr>\n");
         printf("<tr>\n");
-        printf("<td align=right><b>Version %s</b></td>\n", ePerl_Version);
+        printf("<td align=right><b>Version %s</b></td>\n", eperl_version.v_short);
         printf("</tr>\n");
         printf("</table>\n");
         printf("<p>\n");
@@ -133,9 +137,9 @@
 
 void give_version(void)
 {
-    fprintf(stdout, "%s\n", ePerl_Hello);
+    fprintf(stdout, "%s\n", eperl_version.v_tex);
     fprintf(stdout, "\n");
-    fprintf(stdout, "Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>\n");
+    fprintf(stdout, "Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>\n");
     fprintf(stdout, "\n");
     fprintf(stdout, "This program is distributed in the hope that it will be useful,\n");
     fprintf(stdout, "but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
@@ -144,20 +148,6 @@
     fprintf(stdout, "\n");
 }
 
-void give_version_extended(void)
-{
-    give_version();
-    fprintf(stdout, "Characteristics of this binary:\n");
-    fprintf(stdout, "  Perl Version    : %s (%s)\n", AC_perl_vers, AC_perl_prog);
-    fprintf(stdout, "  Perl I/O Layer  : %s\n", PERL_IO_LAYER_ID);
-    fprintf(stdout, "  Perl Library    : %s/CORE/libperl.a\n", AC_perl_archlib);
-    fprintf(stdout, "  Perl DynaLoader : %s\n", AC_perl_dla);
-    fprintf(stdout, "  System Libs     : %s\n", AC_perl_libs);
-    fprintf(stdout, "  Built User      : %s\n", AC_build_user);
-    fprintf(stdout, "  Built Time      : %s\n", AC_build_time_iso);
-    fprintf(stdout, "\n");
-}
-
 void give_readme(void)
 {
     fprintf(stdout, ePerl_README);
@@ -172,7 +162,7 @@
 {
     if (mode == MODE_NPHCGI)
         HTTP_PrintResponseHeaders("");
-    printf("Content-Type: image/gif\n\n");
+    printf("Content-Type: image/gif\r\n\r\n");
     fwrite(ePerl_LOGO_data, ePerl_LOGO_size, 1, stdout);
 }
 
@@ -180,7 +170,7 @@
 {
     if (mode == MODE_NPHCGI)
         HTTP_PrintResponseHeaders("");
-    printf("Content-Type: image/gif\n\n");
+    printf("Content-Type: image/gif\r\n\r\n");
     fwrite(ePerl_POWERED_data, ePerl_POWERED_size, 1, stdout);
 }
 
@@ -306,8 +296,6 @@
 {
     DECL_EXRC;
     FILE *fp = NULL;
-    FILE *er = NULL;
-    FILE *out = NULL;
     char *cpBuf = NULL;
     char *cpBuf2 = NULL;
     char *cpBuf3 = NULL;
@@ -326,10 +314,9 @@
     char *source = NULL;
     char sourcedir[2048];
     char *cp;
-    static PerlInterpreter *my_perl = NULL; 
     struct stat st;
+    char *cpOut0 = NULL;
     char *cpOut = NULL;
-    int size;
     struct passwd *pw;
     struct passwd *pw2;
     struct group *gr;
@@ -446,7 +433,7 @@
                 give_version();
                 myexit(EX_OK);
             case 'V':
-                give_version_extended();
+                give_version_extended_perl();
                 myexit(EX_OK);
             case 'h':
                 give_usage(progname);
@@ -521,7 +508,8 @@
 
         /*  determine whether pure CGI or NPH-CGI mode */ 
         if ((cp = getenv("SCRIPT_FILENAME")) != NULL) { 
-            strcpy(ca, cp);
+            strncpy(ca, cp, sizeof(ca));
+            ca[sizeof(ca)-1] = NUL;
             if ((cp = strrchr(ca, '/')) != NULL) 
                 *cp++ = NUL;
             else 
@@ -536,7 +524,8 @@
         }
 
         /* set the command line for ``ps'' output */
-        sprintf(ca, "%s %s [%sCGI/SSSL]", argv[0], source, mode == MODE_NPHCGI ? "NPH-" : "");
+        snprintf(ca, sizeof(ca), "%s %s [%sCGI/SSSL]", argv[0], source, mode == MODE_NPHCGI ? "NPH-" : "");
+        ca[sizeof(ca)-1] = NUL;
         argv[0] = strdup(ca);
     }
     /*
@@ -581,7 +570,8 @@
 
         /*  determine whether pure CGI or NPH-CGI mode */ 
         if ((cp = getenv("SCRIPT_FILENAME")) != NULL) { 
-            strcpy(ca, cp);
+            strncpy(ca, cp, sizeof(ca));
+            ca[sizeof(ca)-1] = NUL;
             if ((cp = strrchr(ca, '/')) != NULL) 
                 *cp++ = NUL;
             else 
@@ -596,7 +586,8 @@
         }
 
         /* set the command line for ``ps'' output */
-        sprintf(ca, "%s %s [%sCGI/stand-alone]", argv[0], source, mode == MODE_NPHCGI ? "NPH-" : "");
+        snprintf(ca, sizeof(ca), "%s %s [%sCGI/stand-alone]", argv[0], source, mode == MODE_NPHCGI ? "NPH-" : "");
+        ca[sizeof(ca)-1] = NUL;
         argv[0] = strdup(ca);
     }
     /*
@@ -836,7 +827,8 @@
                     dir_home = getcwd(NULL, 1024);
 
                     /* determine physical dir of file */
-                    strcpy(dir_tmp, source);
+                    strncpy(dir_tmp, source, sizeof(dir_tmp));
+                    dir_tmp[sizeof(dir_tmp)-1] = NUL;
                     if ((cp = strrchr(dir_tmp, '/')) == NULL) {
                         if (DO_FOR_FAILED_STEP == STOP_AND_ERROR) {
                             PrintError(mode, source, NULL, NULL, "Invalid script ``%s'': no absolute path", source);
@@ -943,8 +935,9 @@
         cpPort = getenv("SERVER_PORT");
         if (stringEQ(cpPort, "80"))
             cpPort = NULL;
-        sprintf(ca, "http://%s%s%s%s", 
+        snprintf(ca, sizeof(ca), "http://%s%s%s%s", 
                 cpHost, cpPort != NULL ? ":" : "", cpPort != NULL ? cpPort : "", cpPath);
+        ca[sizeof(ca)-1] = NUL;
         env = mysetenv(env, "SCRIPT_SRC_URL", "%s", ca);
         env = mysetenv(env, "SCRIPT_SRC_URL_FILE", "%s", filename(ca));
         env = mysetenv(env, "SCRIPT_SRC_URL_DIR", "%s", dirname(ca));
@@ -966,14 +959,15 @@
         env = mysetenv(env, "SCRIPT_SRC_OWNER", "%s", pw->pw_name);
     else
         env = mysetenv(env, "SCRIPT_SRC_OWNER", "unknown-uid-%d", st.st_uid);
-    env = mysetenv(env, "VERSION_INTERPRETER", "%s", ePerl_WebID);
+    env = mysetenv(env, "VERSION_INTERPRETER", "%s", eperl_version.v_web);
     env = mysetenv(env, "VERSION_LANGUAGE", "Perl/%s", AC_perl_vers);
 
     /* optionally run the ePerl preprocessor */
     if (fPP) {
         /* switch to directory where script stays */
         getcwd(cwd, MAXPATHLEN);
-        strcpy(sourcedir, source);
+        strncpy(sourcedir, source, sizeof(sourcedir));
+        sourcedir[sizeof(sourcedir)-1] = NUL;
         for (cp = sourcedir+strlen(sourcedir); cp > sourcedir && *cp != '/'; cp--)
             ;
         *cp = NUL;
@@ -996,7 +990,8 @@
     cpScript = cpBuf2;
 
     /* write buffer to temporary script file */
-    strcpy(perlscript, mytmpfile("ePerl.script"));
+    strncpy(perlscript, mytmpfile("ePerl.script"), sizeof(perlscript));
+    perlscript[sizeof(perlscript)-1] = NUL;
 #ifndef DEBUG_ENABLED
     unlink(perlscript);
 #endif
@@ -1023,41 +1018,19 @@
         fclose(fp); fp = NULL;
     }
 
-    /* open a file for Perl's STDOUT channel
-       and redirect stdout to the new channel */
-    strcpy(perlstdout, mytmpfile("ePerl.stdout"));
+    /* temporary filename for Perl's STDOUT channel */
+    strncpy(perlstdout, mytmpfile("ePerl.stdout"), sizeof(perlstdout));
+    perlstdout[sizeof(perlstdout)-1] = NUL;
 #ifndef DEBUG_ENABLED
     unlink(perlstdout);
 #endif
-    if ((out = fopen(perlstdout, "w")) == NULL) {
-        PrintError(mode, source, NULL, NULL, "Cannot open STDOUT file `%s' for writing", perlstdout);
-        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
-    }
-    IO_redirect_stdout(out);
 
-    /* open a file for Perl's STDERR channel 
-       and redirect stderr to the new channel */
-    strcpy(perlstderr, mytmpfile("ePerl.stderr"));
+    /* temporary filename for Perl's STDERR channel */
+    strncpy(perlstderr, mytmpfile("ePerl.stderr"), sizeof(perlstderr));
+    perlstderr[sizeof(perlstderr)-1] = NUL;
 #ifndef DEBUG_ENABLED
     unlink(perlstderr);
 #endif
-    if ((er = fopen(perlstderr, "w")) == NULL) {
-        PrintError(mode, source, NULL, NULL, "Cannot open STDERR file `%s' for writing", perlstderr);
-        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
-    }
-    IO_redirect_stderr(er);
-
-    /*  now allocate the Perl interpreter  */
-    my_perl = perl_alloc();   
-    perl_construct(my_perl); 
-    /* perl_destruct_level = 1; */
-
-    /*  initialise the Perl Locale environment  */
-#if AC_perl_vnum < 500400
-    perl_init_i18nl14n(1); /* Perl 5.003 or lower */
-#else
-    perl_init_i18nl10n(1); /* Perl 5.004 or higher */
-#endif
 
     /*  create command line...  */
     myargc = 0;
@@ -1075,105 +1048,43 @@
     /*  - and the script itself  */
     myargv[myargc++] = perlscript;   
 
-    /*  now parse the script! 
-        NOTICE: At this point, the script gets 
-        only _parsed_, not evaluated/executed!  */
-#ifdef HAVE_PERL_DYNALOADER
-    rc = perl_parse(my_perl, Perl5_XSInit, myargc, myargv, env);
-#else
-    rc = perl_parse(my_perl, NULL, myargc, myargv, env);
-#endif
-    if (rc != 0) { 
-        if (fCheck && mode == MODE_FILTER) {
-            fclose(er); er = NULL;
-            IO_restore_stdout();
-            IO_restore_stderr();
-            if ((cpBuf = ePerl_ReadErrorFile(perlstderr, perlscript, source)) != NULL) {
-                fprintf(stderr, cpBuf);
-            }
-            CU(EX_IOERR);
-        }
-        else {
-            fclose(er); er = NULL;
-            PrintError(mode, source, perlscript, perlstderr, "Perl parsing error (interpreter rc=%d)", rc);
-            CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
-        }
-    }
-
-    /* Stop when we are just doing a syntax check */
-    if (fCheck && mode == MODE_FILTER) {
-        fclose(er); er = NULL;
-        IO_restore_stdout();
-        IO_restore_stderr();
-        fprintf(stderr, "%s syntax OK\n", source);
-        CU(EX_OK);
-    }
-
-    /* change to directory of script:
-       this actually is not important to us, but really useful 
-       for the ePerl source file programmer!! */
-    cwd[0] = NUL;
-    if (!keepcwd) {
-        /* if running as a Unix filter remember the cwd for outputfile */
-        if (mode == MODE_FILTER)
-            getcwd(cwd, MAXPATHLEN);
-        /* determine dir of source file and switch to it */
-        strcpy(sourcedir, source);
-        for (cp = sourcedir+strlen(sourcedir); cp > sourcedir && *cp != '/'; cp--)
-            ;
-        *cp = NUL;
-        chdir(sourcedir);
-    }
-
-    /*  Set the previously remembered Perl 5 scalars (option -d) */
-    Perl5_SetRememberedScalars();
-
-    /*  Force unbuffered I/O */
-    Perl5_ForceUnbufferedStdout();
-
-    /*  NOW IT IS TIME to evaluate/execute the script!!! */
-    rc = perl_run(my_perl);
-
-    /*  pre-close the handles, to be able to check
-        its size and to be able to display the contents */
-    fclose(out); out = NULL;
-    fclose(er);  er  = NULL;
-
-    /*  when the Perl interpreter failed or there
-        is data on stderr, we print a error page */
-    if (stat(perlstderr, &st) == 0)
-        size = st.st_size;
-    else
-        size = 0;
-    if (rc != 0 || size > 0) {
-        PrintError(mode, source, perlscript, perlstderr, "Perl runtime error (interpreter rc=%d)", rc);
-        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
+    rc = Perl5_Run(myargc, myargv, mode, fCheck, keepcwd, source, env, perlscript, perlstderr, perlstdout);
+    /*  Return code:
+     *     0: ok
+     *    -1: fCheck && mode == MODE_FILTER and
+     *        no error detected by perl_parse()
+     *    otherwise: error detected by perl_parse() or perl_run()
+     *  Error message has already been delivered bu Perl5_Run.
+     */
+    if (rc != 0) {
+        if (rc == -1)
+            CU(EX_OK);
+        CU(mode == MODE_FILTER ? EX_FAIL : EX_OK);
     }
 
     /*  else all processing was fine, so
         we read in the stdout contents */
     if ((cpOut = ePerl_ReadSourceFile(perlstdout, &cpOut, &nOut)) == NULL) {
         PrintError(mode, source, NULL, NULL, "Cannot open STDOUT file `%s' for reading", perlstdout);
-        CU(mode == MODE_FILTER ? EX_IOERR : EX_OK);
+        CU(mode == MODE_FILTER ? EX_FAIL : EX_OK);
     }
+    cpOut0 = cpOut; /* cpOut will move by HTTP_PrintResponseHeaders() later */
     stat(perlstdout, &st);
 
-    /* ok, now recover the stdout and stderr and
-       print out the real contents on stdout or outputfile */
-    IO_restore_stdout();
-    IO_restore_stderr();
-
     /*  if we are running as a NPH-CGI/1.1 script
         we had to provide the HTTP reponse headers ourself */
     if (mode == MODE_NPHCGI) {
-        HTTP_PrintResponseHeaders(cpOut);
+        char *p = HTTP_PrintResponseHeaders(cpOut);
+        /* HTTP_PrintResponseHeader will skip HTTP status line */
+        nOut -= (p - cpOut); /* adjust length */
+        cpOut = p; /* points top of HTTP response header */
 
         /* if there are no HTTP header lines, we print a basic
            Content-Type header which should be ok */
         if (!HTTP_HeadersExists(cpOut)) {
-            printf("Content-Type: text/html\n");
-            printf("Content-Length: %d\n", nOut);
-            printf("\n");
+            printf("Content-Type: text/html\r\n");
+            printf("Content-Length: %d\r\n", nOut);
+            printf("\r\n");
         }
     }
     else if (mode == MODE_CGI) {
@@ -1191,10 +1102,6 @@
         HTTP_StripResponseHeaders(&cpOut, &nOut);
     }
 
-    /* now when the request was not a HEAD request we create the output */
-    cp = getenv("REQUEST_METHOD");
-    if (! ((mode == MODE_CGI || mode == MODE_NPHCGI) &&
-           cp != NULL && stringEQ(cp, "HEAD"))) {
         if (outputfile != NULL && stringNE(outputfile, "-")) {
             /* if we remembered current working dir, restore it now */
             if (mode == MODE_FILTER && cwd[0] != NUL)
@@ -1213,22 +1120,10 @@
             /* make sure that the data is out before we exit */
             fflush(stdout);
         }
-    }
 
     CUS: /* the Clean Up Sequence */
 
-    /* Ok, the script got evaluated. Now we can destroy 
-       and de-allocate the Perl interpreter */
-    if (my_perl) {
-       perl_destruct(my_perl);                                                    
-       perl_free(my_perl);
-    }
-
     /* close all still open file handles */
-    if (out)
-        fclose(out);
-    if (er)
-        fclose(er);
     if (fp)
         fclose(fp);
 
@@ -1237,8 +1132,8 @@
         free(cpBuf);
     if (cpBuf2)
         free(cpBuf2);
-    if (cpOut)
-        free(cpOut);
+    if (cpOut0)
+        free(cpOut0);
 
     /* remove temporary files */
 #ifndef DEBUG_ENABLED
diff -u -Naur eperl-2.2.14/eperl_parse.c eperl-2.2.14.fink/eperl_parse.c
--- eperl-2.2.14/eperl_parse.c	Fri Jul 10 03:50:48 1998
+++ eperl-2.2.14.fink/eperl_parse.c	Wed Nov 17 12:47:04 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -66,7 +66,8 @@
     va_list ap;
 
     va_start(ap, str);
-    vsprintf(ePerl_ErrorString, str, ap);
+    vsnprintf(ePerl_ErrorString, sizeof(ePerl_ErrorString), str, ap);
+    ePerl_ErrorString[sizeof(ePerl_ErrorString)-1] = NUL;
     va_end(ap);
     return;
 }
@@ -79,6 +80,7 @@
     return ePerl_ErrorString;
 }
 
+#if 0 /* unsafe ? */
 /*
 **  fprintf for internal buffer 
 */
@@ -91,10 +93,26 @@
     va_end(ap);
     return cpOut+strlen(cpOut);
 }
+#else /* safe version */
+char *ePerl_fnprintf(char *cpOut, int *n, char *str, ...)
+{
+    va_list ap;
+
+    if (*n <= 0) { abort(); } /* hope NEVER */
+    va_start(ap, str);
+    vsnprintf(cpOut, *n, str, ap);
+    cpOut[*n - 1] = NUL;
+    va_end(ap);
+    *n -= strlen(cpOut);
+    if (*n <= 0) { abort(); } /* hope NEVER */
+    return cpOut+strlen(cpOut);
+}
+#endif
 
 /*
 **  fwrite for internal buffer 
 */
+#if 0 /* unsafe */
 char *ePerl_fwrite(char *cpBuf, int nBuf, int cNum, char *cpOut)
 {
     char *cp;
@@ -106,7 +124,24 @@
     *cp = NUL;
     return cp;
 }
+#else /* safe */
+char *ePerl_fnwrite(char *cpBuf, int nBuf, int cNum, char *cpOut, int *cpOutLen)
+{
+    char *cp;
+    int n;
+
+    n = nBuf*cNum;
+    if (*cpOutLen < n) { abort(); }
+    (void)strncpy(cpOut, cpBuf, n);
+    cpOut[*cpOutLen - 1] = NUL;
+    cp = cpOut + n;
+    *cp = NUL;
+    *cpOutLen -= n;
+    return cp;
+}
+#endif
 
+#if 0 /* unsafe */
 /*
 **  fwrite for internal buffer WITH character escaping
 */
@@ -129,6 +164,29 @@
     *cpO = NUL;
     return cpO;
 }
+#else /* safe */
+char *ePerl_Efnwrite(char *cpBuf, int nBuf, int cNum, char *cpOut, int *n)
+{
+    char *cpI;
+    char *cpO;
+
+    if (*n <= 0) { abort(); }
+    for (cpI = cpBuf, cpO = cpOut; cpI < (cpBuf+(nBuf*cNum)); ) {
+        switch (*cpI) {
+            case '"':  *cpO++ = '\\'; *cpO++ = *cpI++; *n -= 2;    break;
+            case '@':  *cpO++ = '\\'; *cpO++ = *cpI++; *n -= 2;    break;
+            case '$':  *cpO++ = '\\'; *cpO++ = *cpI++; *n -= 2;    break;
+            case '\\': *cpO++ = '\\'; *cpO++ = *cpI++; *n -= 2;    break;
+            case '\t': *cpO++ = '\\'; *cpO++ = 't'; cpI++; *n -= 2;break;
+            case '\n': *cpO++ = '\\'; *cpO++ = 'n'; cpI++; *n -= 2;break;
+            default: *cpO++ = *cpI++; *n -= 1;
+        }
+        if (*n <= 0) { abort(); }
+    }
+    *cpO = NUL;
+    return cpO;
+}
+#endif
 
 
 /*
@@ -247,6 +305,7 @@
     { NULL, NUL }
 };
 
+#if 0 /* unsafe */
 char *ePerl_Cfwrite(char *cpBuf, int nBuf, int cNum, char *cpOut)
 {
     char *cpI;
@@ -278,6 +337,42 @@
     *cpO = NUL;
     return cpO;
 }
+#else /* safe */
+char *ePerl_Cfnwrite(char *cpBuf, int nBuf, int cNum, char *cpOut, int *cpOutLen)
+{
+    char *cpI;
+    char *cpO;
+    int i;
+    int n;
+    char *cpE;
+
+    if (*cpOutLen <= 0) { abort(); }
+    cpI = cpBuf;
+    cpO = cpOut;
+    cpE = cpBuf+(nBuf*cNum);
+    while (cpI < cpE) {
+        if (*cpI == '&') {
+            for (i = 0; html2char[i].h != NULL; i++) {
+                n = strlen(html2char[i].h);
+                if (cpI+1+n+1 < cpE) {
+                    if (*(cpI+1+n) == ';') {
+                        if (strncmp(cpI+1, html2char[i].h, n) == 0) {
+                            *cpO++ = html2char[i].c;
+                            if (--*cpOutLen <= 0) { abort(); }
+                            cpI += 1+n+1;
+                            continue;
+                        }
+                    }
+                }
+            }
+        }
+        *cpO++ = *cpI++;
+        if (--*cpOutLen <= 0) { abort(); }
+    }
+    *cpO = NUL;
+    return cpO;
+}
+#endif
 
 
 /*
@@ -298,7 +393,7 @@
     return NULL;
 }
 
-char *strnstr(char *buf, char *str, int n)
+char *ePerl_strnstr(char *buf, char *str, int n)
 {
     char *cp;
     char *cpe;
@@ -326,15 +421,6 @@
     return NULL;
 }
 
-char *strndup(char *buf, int n)
-{
-    char *cp;
-
-    cp = (char *)malloc(n+1);
-    strncpy(cp, buf, n);
-    return cp;
-}
-
 
 /*
 **  convert buffer from bristled format to plain format
@@ -344,6 +430,7 @@
     char *rc;
     char *cpOutBuf = NULL;
     char *cpOut = NULL;
+    int cpOutLen = 0;
     char *cps, *cpe;
     char *cps2, *cpe2;
     int nBuf;
@@ -369,6 +456,7 @@
         CU(NULL);
     }
     cpOut = cpOutBuf;
+    cpOutLen = n;
 
     /* now step through the file and convert it to legal Perl code.
        This is a bit complicated because we have to make sure that
@@ -378,7 +466,7 @@
     while (cps < cpEND) {
 
         if (ePerl_case_sensitive_delimiters)
-            cpe = strnstr(cps, ePerl_begin_delimiter, cpEND-cps);
+            cpe = ePerl_strnstr(cps, ePerl_begin_delimiter, cpEND-cps);
         else
             cpe = strncasestr(cps, ePerl_begin_delimiter, cpEND-cps);
         if (cpe == NULL) {
@@ -393,25 +481,25 @@
                 while (cps2 < cpEND && (cpe2 = strnchr(cps2, '\n', cpEND-cps2)) != NULL) {
                     if (ePerl_line_continuation && cps < cpe2 && *(cpe2-1) == '\\') {
                         if (cpe2-1-cps2 > 0) {
-                            cpOut = ePerl_fprintf(cpOut, "print \"");
-                            cpOut = ePerl_Efwrite(cps2, cpe2-1-cps2, 1, cpOut);
-                            cpOut = ePerl_fprintf(cpOut, "\";");
+                            cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                            cpOut = ePerl_Efnwrite(cps2, cpe2-1-cps2, 1, cpOut, &cpOutLen);
+                            cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\";");
                         }
-                        cpOut = ePerl_fprintf(cpOut, "\n");
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\n");
                     }
                     else {
-                        cpOut = ePerl_fprintf(cpOut, "print \"");
-                        cpOut = ePerl_Efwrite(cps2, cpe2-cps2, 1, cpOut);
-                        cpOut = ePerl_fprintf(cpOut, "\\n\";\n");
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                        cpOut = ePerl_Efnwrite(cps2, cpe2-cps2, 1, cpOut, &cpOutLen);
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\\n\";\n");
                     }
                     cps2 = cpe2+1;
                 }
                 /* then do the remainder which is not
                    finished by a newline */
                 if (cpEND > cps2) {
-                    cpOut = ePerl_fprintf(cpOut, "print \"");
-                    cpOut = ePerl_Efwrite(cps2, cpEND-cps2, 1, cpOut);
-                    cpOut = ePerl_fprintf(cpOut, "\";");
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                    cpOut = ePerl_Efnwrite(cps2, cpEND-cps2, 1, cpOut, &cpOutLen);
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\";");
                 }
             }
             break; /* and break the whole processing step */
@@ -428,30 +516,30 @@
                 while ((cpe2 = strnchr(cps2, '\n', cpe-cps2)) != NULL) {
                     if (ePerl_line_continuation && cps < cpe2 && *(cpe2-1) == '\\') {
                         if (cpe2-1-cps2 > 0) {
-                            cpOut = ePerl_fprintf(cpOut, "print \"");
-                            cpOut = ePerl_Efwrite(cps2, cpe2-1-cps2, 1, cpOut);
-                            cpOut = ePerl_fprintf(cpOut, "\";");
+                            cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                            cpOut = ePerl_Efnwrite(cps2, cpe2-1-cps2, 1, cpOut, &cpOutLen);
+                            cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\";");
                         }
-                        cpOut = ePerl_fprintf(cpOut, "\n");
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\n");
                     }
                     else {
-                        cpOut = ePerl_fprintf(cpOut, "print \"");
-                        cpOut = ePerl_Efwrite(cps2, cpe2-cps2, 1, cpOut);
-                        cpOut = ePerl_fprintf(cpOut, "\\n\";\n");
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                        cpOut = ePerl_Efnwrite(cps2, cpe2-cps2, 1, cpOut, &cpOutLen);
+                        cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\\n\";\n");
                     }
                     cps2 = cpe2+1;
                 }
                 if (cpe > cps2) {
-                    cpOut = ePerl_fprintf(cpOut, "print \"");
-                    cpOut = ePerl_Efwrite(cps2, cpe-cps2, 1, cpOut);
-                    cpOut = ePerl_fprintf(cpOut, "\";");
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print \"");
+                    cpOut = ePerl_Efnwrite(cps2, cpe-cps2, 1, cpOut, &cpOutLen);
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\";");
                 }
             }
 
             /* just output a leading space to make
                the -x display more readable. */
             if (cpOut > cpOutBuf && *(cpOut-1) != '\n') 
-                cpOut = ePerl_fprintf(cpOut, " ");
+                cpOut = ePerl_fnprintf(cpOut, &cpOutLen, " ");
 
             /* skip the start delimiter */
             cps = cpe+strlen(ePerl_begin_delimiter);
@@ -460,7 +548,7 @@
              * e.g. <:=$var:>
              */
             if (*cps == '=') {
-                cpOut = ePerl_fprintf(cpOut, "print ");
+                cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "print ");
                 cps++;
             }
 
@@ -476,7 +564,7 @@
 
             /* move forward to end of ePerl block. */
             if (ePerl_case_sensitive_delimiters)
-                cpe = strnstr(cpe, ePerl_end_delimiter, cpEND-cpe);
+                cpe = ePerl_strnstr(cpe, ePerl_end_delimiter, cpEND-cpe);
             else
                 cpe = strncasestr(cpe, ePerl_end_delimiter, cpEND-cpe);
             if (cpe == NULL) {
@@ -493,16 +581,16 @@
             /* pass through the ePerl block without changes! */
             if (cpe2 > cps) { 
                 if (ePerl_convert_entities == TRUE)
-                    cpOut = ePerl_Cfwrite(cps, cpe2-cps, 1, cpOut);
+                    cpOut = ePerl_Cfnwrite(cps, cpe2-cps, 1, cpOut, &cpOutLen);
                 else
-                    cpOut = ePerl_fwrite(cps, cpe2-cps, 1, cpOut);
+                    cpOut = ePerl_fnwrite(cps, cpe2-cps, 1, cpOut, &cpOutLen);
 
                 /* be smart and automatically add a semicolon
                    if not provided at the end of the ePerl block.
                    But know the continuation indicator "_". */
                 if ((*(cpe2-1) != ';') &&
                     (*(cpe2-1) != '_')   )
-                    cpOut = ePerl_fprintf(cpOut, ";");
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, ";");
                 if (*(cpe2-1) == '_') 
                     cpOut = cpOut - 1;
             }
@@ -510,13 +598,13 @@
             /* end preserve newlines for correct line numbers */
             for ( ; cpe2 <= cpe; cpe2++)
                 if (*cpe2 == '\n')
-                    cpOut = ePerl_fprintf(cpOut, "\n");
+                    cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\n");
 
             /* output a trailing space to make
                the -x display more readable when
                no newlines have finished the block. */
             if (cpOut > cpOutBuf && *(cpOut-1) != '\n') 
-                cpOut = ePerl_fprintf(cpOut, " ");
+                cpOut = ePerl_fnprintf(cpOut, &cpOutLen, " ");
 
             /* and adjust the current position to the first character
                after the end delimiter */
@@ -533,7 +621,7 @@
                 if (cps < cpEND)
                     cps++;
                 /* but preserve the newline in the script */
-                cpOut = ePerl_fprintf(cpOut, "\n");
+                cpOut = ePerl_fnprintf(cpOut, &cpOutLen, "\n");
             }
         }
     }
